# GDK Procfile services:
# - all commands must start with 'exec'
# - no inline shell scripts ('&&' or ';')
#

# Datasources
#
redis: exec redis-server <%= config.redis.dir.join('redis.conf') %>
redis-cluster: exec support/redis-cluster-signal-wrapper <%= config.redis_cluster.dir %> <%= config.hostname %> <%= config.redis_cluster.dev_port_1%>:<%= config.redis_cluster.dev_port_2%>:<%= config.redis_cluster.dev_port_3%> <%= config.redis_cluster.test_port_1%>:<%= config.redis_cluster.test_port_2%>:<%= config.redis_cluster.test_port_3%>
<%= '#' unless config.object_store? %>minio: exec /usr/bin/env MINIO_REGION=gdk MINIO_ACCESS_KEY=minio MINIO_SECRET_KEY=gdk-minio minio server -C minio/config --address "<%= config.object_store.host %>:<%= config.object_store.port %>" --console-address "<%= config.object_store.host %>:<%= config.object_store.console_port %>" --compat minio/data
postgresql: exec support/postgresql-signal-wrapper <%= config.postgresql.bin %> -D <%= config.postgresql.data_dir %> -k <%= config.postgresql.dir %> -h '<%= config.postgresql.__active_host %>'
<%= '#' unless config.postgresql.replica? %>postgresql-replica: exec support/postgresql-signal-wrapper <%= config.postgresql.bin %> -D <%= config.postgresql.replica.data_directory %> -k <%= config.postgresql.replica.root_directory %> -h ''
<%= '#' unless config.postgresql.replica_2? %>postgresql-replica-2: exec support/postgresql-signal-wrapper <%= config.postgresql.bin %> -D <%= config.postgresql.replica_2.data_directory %> -k <%= config.postgresql.replica_2.root_directory %> -h ''
<%= '#' unless config.openldap? %>openldap: exec support/exec-cd gitlab-openldap libexec/slapd -F slapd.d -d2 -h "ldap://<%= config.hostname %>:3890"
<%= '#' unless config.pgbouncer_replicas? %>pgbouncer1: exec pgbouncer pgbouncers/pgbouncer-replica-1.ini
<%= '#' unless config.pgbouncer_replicas? %>pgbouncer2: exec pgbouncer pgbouncers/pgbouncer-replica-2.ini
<%= '#' unless config.pgbouncer_replicas? && config.postgresql.replica_2? %>pgbouncer2-1: exec pgbouncer pgbouncers/pgbouncer-replica-2-1.ini
<%= '#' unless config.pgbouncer_replicas? && config.postgresql.replica_2? %>pgbouncer2-2: exec pgbouncer pgbouncers/pgbouncer-replica-2-2.ini
<%= '#' unless config.load_balancing.discover? %>consul: exec /usr/bin/env PGPASSWORD=gitlab consul agent -config-file consul/config.json -dev

# Geo
#
<%= '#' unless config.geo? %>postgresql-geo: exec support/postgresql-signal-wrapper <%= config.postgresql.bin %> -D <%= config.postgresql.geo.dir.join('data') %> -k <%= config.postgresql.geo.dir %> -h '<%= config.postgresql.geo.__active_host %>'
<%= '#' unless config.geo? && config.geo.secondary? %>geo-cursor: exec /usr/bin/env RAILS_ENV=development RAILS_RELATIVE_URL_ROOT=$relative_url_root GDK_GEO_SECONDARY=1 support/geo-logcursor

# Backend services
#
gitlab-workhorse: exec /usr/bin/env PATH="<%= config.gitlab.dir.join('workhorse') %>:$PATH" <%= 'GEO_SECONDARY_PROXY=0' unless config.geo? %> gitlab-workhorse -<%= config.workhorse.__listen_settings.__type %> <%= config.workhorse.__listen_settings.__address %> -documentRoot <%= config.gitlab.dir.join('public') %> -developmentMode -secretPath <%= config.gitlab.dir.join('.gitlab_workhorse_secret') %> -config <%= config.gitlab.dir.join('workhorse', 'config.toml') %> -listenAddr <%= config.workhorse.__command_line_listen_addr %> -logFormat json <% if config.prometheus.enabled? %>-prometheusListenAddr "<%= config.hostname %>:<%= config.prometheus.workhorse_exporter_port %>"<% end %>
rails-background-jobs: exec /usr/bin/env PATH="<%= config.gitlab_metrics_exporter.dir %>/bin:$PATH" SIDEKIQ_VERBOSE=<%= config.gitlab.rails_background_jobs.verbose? %> SIDEKIQ_QUEUES=default,mailers,email_receiver,hashed_storage:hashed_storage_migrator,hashed_storage:hashed_storage_project_migrate,hashed_storage:hashed_storage_project_rollback,hashed_storage:hashed_storage_rollbacker,project_import_schedule,service_desk_email_receiver CACHE_CLASSES=$cache_classes BUNDLE_GEMFILE=$bundle_gemfile SIDEKIQ_WORKERS=1 ENABLE_BOOTSNAP=<%= config.gitlab.rails.bootsnap? %> RAILS_ENV=development RAILS_RELATIVE_URL_ROOT=$relative_url_root GITALY_DISABLE_REQUEST_LIMITS=<%= config.gitlab.gitaly_disable_request_limits %><%= " GDK_GEO_SECONDARY=1" if config.geo? && config.geo.secondary? %><%= " GITLAB_VALIDATE_DATABASE_CONFIG=0" if config.cells? %> support/exec-cd gitlab bin/background_jobs start_foreground --timeout <%= config.gitlab.rails_background_jobs.timeout %>
<%= '#' unless config.gitlab_k8s_agent.enabled %>gitlab-k8s-agent: exec /usr/bin/env OWN_PRIVATE_API_URL='<%= config.gitlab_k8s_agent.__private_api_url %>' <%= config.gitlab_k8s_agent.__command %> --configuration-file '<%= config.gitlab_k8s_agent.__config_file %>'
<% if config.praefect? -%>
praefect: exec <%= config.praefect.__praefect_build_bin_path %> -config <%= config.praefect.config_file %>
<% config.praefect.__nodes.each_with_index do |praefect_node, index| -%>
<%= praefect_node.service_name %>: exec /usr/bin/env GITALY_TESTING_ENABLE_ALL_FEATURE_FLAGS=<%= config.gitaly.enable_all_feature_flags? %> GITALY_LOG_REQUEST_METHOD_DENY_PATTERN="^/grpc.health.v1.Health/Check$" support/exec-cd gitaly <%= config.gitaly.__gitaly_build_bin_path %> <%= config.gdk_root.join(praefect_node.config_file) %>
<% end -%>
<% end -%>
<% if config.gitaly? -%>
gitaly: exec /usr/bin/env GITALY_TESTING_ENABLE_ALL_FEATURE_FLAGS=<%= config.gitaly.enable_all_feature_flags? %> support/exec-cd gitaly <%= config.gitaly.__gitaly_build_bin_path %> <%= config.gitaly.config_file %>
<% end -%>

# Frontend services
#
<%= '#' unless config.gitlab_ui? %>gitlab-ui: exec /usr/bin/env NODE_ENV=development support/exec-cd gitlab-ui yarn build --watch
<%= '#' unless config.webpack? %>webpack: exec /usr/bin/env NODE_ENV=development DEV_SERVER_STATIC=<%= config.webpack.static?%> WEBPACK_VENDOR_DLL=<%= config.webpack.vendor_dll? %> DEV_SERVER_INCREMENTAL=<%= config.webpack.incremental? %> DEV_SERVER_INCREMENTAL_TTL=<%= config.webpack.incremental_ttl %> DEV_SERVER_LIVERELOAD=<%= config.webpack.live_reload? %> NO_SOURCEMAPS=<%= !config.webpack.sourcemaps? %> DEV_SERVER_PORT=<%= config.webpack.port %> DEV_SERVER_PUBLIC_ADDR=<%= config.webpack.__dev_server_public %> DEV_SERVER_HOST=<%= config.webpack.host %> DEV_SERVER_ALLOWED_HOSTS="<%= config.webpack.allowed_hosts.join(',') %>" GITLAB_UI_WATCH=<%= config.gitlab_ui? %> support/exec-cd gitlab yarn dev-server
<%= '#' unless config.rails_web? %>rails-web: exec /usr/bin/env PATH="<%= config.gitlab_metrics_exporter.dir %>/bin:$PATH" CACHE_CLASSES=$cache_classes BUNDLE_GEMFILE=$bundle_gemfile ENABLE_BOOTSNAP=<%= config.gitlab.rails.bootsnap? %> RAILS_ENV=development RAILS_RELATIVE_URL_ROOT=$relative_url_root ACTION_CABLE_IN_APP=true ACTION_CABLE_WORKER_POOL_SIZE=<%= config.action_cable.worker_pool_size %> GITALY_DISABLE_REQUEST_LIMITS=<%= config.gitlab.gitaly_disable_request_limits %><%= " GDK_GEO_SECONDARY=1" if config.geo? && config.geo.secondary? %><%= " GITLAB_VALIDATE_DATABASE_CONFIG=0" if config.cells? %> support/exec-cd gitlab bin/web start_foreground
<%= '#' unless config.gitlab_pages? %>gitlab-pages: exec gitlab-pages/bin/gitlab-pages -config=<%= config.gdk_root.join('gitlab-pages', 'gitlab-pages.conf') %>

# Docker
#
<%= '#' unless config.registry? %>registry: exec support/docker-registry

# Monitoring and tracing
#
<%= '#' unless config.grafana? %>grafana: exec support/exec-cd grafana grafana/bin/grafana-server -homepath grafana -config grafana.ini
<%= '#' unless config.prometheus? %>prometheus: exec docker run --rm -p <%= config.prometheus.port %>:9090 -v <%= config.gdk_root.join('prometheus', 'prometheus.yml') %>:/etc/prometheus/prometheus.yml prom/prometheus:v2.25.0
<%= '#' unless config.tracer.jaeger? %>jaeger: exec jaeger/jaeger-<%= config.tracer.jaeger.version %>/jaeger-all-in-one --memory.max-traces 512 --http-server.host-port "<%= config.tracer.jaeger.listen_address %>:5778" --processor.jaeger-binary.server-host-port "<%= config.tracer.jaeger.listen_address %>:6832" --processor.jaeger-compact.server-host-port "<%= config.tracer.jaeger.listen_address %>:6831" --processor.zipkin-compact.server-host-port "<%= config.tracer.jaeger.listen_address %>:5775" --admin.http.host-port "<%= config.tracer.jaeger.listen_address %>:14269" --query.host-port "<%= config.tracer.jaeger.listen_address %>:16686" --collector.http-server.host-port "<%= config.tracer.jaeger.listen_address %>:14268" --collector.grpc-server.host-port "<%= config.tracer.jaeger.listen_address %>:14250" --collector.zipkin.host-port "<%= config.tracer.jaeger.listen_address %>:5555"

# Additional services
#
<%= '#' unless config.sshd? %>sshd: exec <%= config.sshd.__full_command %>
<%= '#' unless config.nginx? %>nginx: exec <%= config.nginx.bin %> -e /dev/stderr -p <%= config.gdk_root.join('nginx') %> -c conf/nginx.conf
<%= '#' unless config.elasticsearch? %>elasticsearch: exec elasticsearch/bin/elasticsearch

<%= '#' unless config.zoekt? %>zoekt-dynamic-indexserver-test: exec /usr/bin/env PATH="$(pwd)/zoekt/bin:$PATH" zoekt/bin/zoekt-dynamic-indexserver -repo_dir zoekt-data/test/data/repos -index_dir zoekt-data/test/index -listen :<%= config.zoekt.index_port_test %>
<%= '#' unless config.zoekt? %>zoekt-webserver-test: exec /usr/bin/env PATH="$(pwd)/zoekt/bin:$PATH" zoekt/bin/zoekt-webserver -index zoekt-data/test/index -rpc -listen :<%= config.zoekt.web_port_test %>
<%= '#' unless config.zoekt? %>zoekt-dynamic-indexserver-development: exec /usr/bin/env PATH="$(pwd)/zoekt/bin:$PATH" zoekt/bin/zoekt-dynamic-indexserver -repo_dir zoekt-data/development/data/repos -index_dir zoekt-data/development/index -listen :<%= config.zoekt.index_port_dev %>
<%= '#' unless config.zoekt? %>zoekt-webserver-development: exec /usr/bin/env PATH="$(pwd)/zoekt/bin:$PATH" zoekt/bin/zoekt-webserver -index zoekt-data/development/index -rpc -listen :<%= config.zoekt.web_port_dev %>

# Gitlab Docs
#
<%= '#' unless config.gitlab_docs? %>gitlab-docs: exec support/gitlab-docs/start-nanoc

# Gitlab Runner Binary
#
<%= '#' unless config.runner.__install_mode_binary %>runner: exec <%= config.runner.bin %> --log-level debug run --config <%= config.runner.config_file %>

# Gitlab Runner Docker
#
<%= '#' unless config.runner.__install_mode_docker && !config.https? %>runner: exec docker run --rm <%= config.runner.__add_host_flags %> -v '<%= config.runner.config_file %>:/etc/gitlab-runner/config.toml' -v /var/run/docker.sock:/var/run/docker.sock <%= config.runner.image %>

# Gitlab Runner Docker with HTTPS
#
<%= '#' unless config.runner.__install_mode_docker && config.https? %>runner: exec docker run --rm <%= config.runner.__add_host_flags %> -v '<%= config.runner.config_file %>:/etc/gitlab-runner/config.toml' -v '<%= config.gdk_root.join(config.nginx.ssl.certificate) %>:/etc/gitlab-runner/certs/<%= config.runner.__ssl_certificate %>' -v /var/run/docker.sock:/var/run/docker.sock <%= config.runner.image %>

# Gitlab Spamcheck
#
<%= '#' unless config.gitlab_spamcheck? %>spamcheck: exec support/exec-cd gitlab-spamcheck ./spamcheck

# Mattermost
#
<%= '#' unless config.mattermost? %>mattermost: exec docker run --rm --sig-proxy=true -v <%= config.gdk_root.join('mattermost', 'data') %>:/mm/mattermost-data/  -v <%= config.gdk_root.join('mattermost', 'mysql') %>:/var/lib/mysql --publish <%= config.mattermost.port %>:8065 <%= config.mattermost.image %>

# Snowplow Micro
#
<%= '#' unless config.snowplow_micro? %>snowplow-micro: exec docker run --rm --mount type=bind,source=<%= config.gdk_root.join('snowplow') %>,destination=/config -p <%= config.snowplow_micro.port %>:9091 <%= config.snowplow_micro.image %> --collector-config /config/snowplow_micro.conf --iglu /config/iglu.json

# Vault
#
<%= '#' unless config.vault? %>vault: exec vault server -dev -dev-listen-address=<%=config.vault.__listen %>
